dofile("./Config/export/utils-prod.lua")

LoLibData=
{
    io.input("./Config/export/iplua.cfg"),
--	RemoteAddress = io.read("*line"),  -- path lockon
	RemoteAddress = io.read("*line"),  -- ip
	RemotePort = io.read("*line"),     --  port
	UpdatePeriod = io.read("*line"),   --
	Debug = io.read("*line"),          --
	io.close(),
--	UpdatePeriod = 2, --In seconds
--	RemoteAddress = "192.168.1.173", --If using a SecureConnection(TCP), please set a unicast adress
--	RemotePort = 10315,
--	Debug = true,
	UseSecureConnection = false, --If true, use TCP. If false, use UDP
	TryToReconnectPeriod = 30, --Delay between each try of reconnection
	ConnectTimeout = 0.1, --Amount of time in second maximum allowed to connect to the server
	
	-- --------------------------------------------------------------------
	-- Fonction de dmarrage du script
	-- --------------------------------------------------------------------
	Start=function(self)
		dofile "lua.lua"	
		socket = require("socket")

--		self.Objects={}

		self.NextUpdateTime=0
		self.NextReconnectTryTime=0
		self.TryingToReconnect=false
		

		-- Initialisation du socket de communication
		if self.UseSecureConnection then
			self.SockCom = socket.tcp()
			if self.SockCom:connect(self.RemoteAddress, self.RemotePort) == nil then
				self.SockCom = nil
				self.NextReconnectTryTime = self.TryToReconnectPeriod
				self.TryingToReconnect = true
			else
				self.SockCom:setoption("tcp-nodelay", true) --No buffer, auto-flush
				self.SockCom:settimeout(0.000001) -- Permet de ne pas bloquer la lecture
			end
		else
			self.SockCom = socket.udp()
			self.SockCom:setpeername(self.RemoteAddress, self.RemotePort)
			self.SockCom:settimeout(0.000001) -- Permet de ne pas bloquer la lecture
		end	
		
		InitSpecialValue()

		local FirstData="PV" .. LoGetPilotName() .. "|" .. LoGetPlayerPlaneId() .. "|" .. LoGetMissionStartTime()

		--Initialisation du journal (log)
		if self.Debug =="1" then
			self.LogFile = io.open("./Temp/Debug-Send.txt","w")
			if self.LogFile then
				self.LogFile:write(FirstData)
				self.LogFile:write("\n")
			end
		end
		
		if self.SockCom then
			rep = self.SockCom:send(FirstData)
			if rep == nil then
				self.SockCom = nil
			end
		end
		
	end,

	-- --------------------------------------------------------------------
	-- Fonction de rafraichissement du script
	-- --------------------------------------------------------------------
	Update=function(self)
		local CurrentTime = LoGetModelTime()

		local ShouldUpdateLog=false;

		if CurrentTime > self.NextUpdateTime then -- Si on a atteind le moment de rafraichissement
			self.NextUpdateTime = CurrentTime + self.UpdatePeriod
		else
			return
		end
		
		-- Vrification des messages d'entres
		if self.SockCom then
			local incomingData = self.SockCom:receive()
			if incomingData then
				if self.Debug == "1" then
					self.LogFile:write("CMD RECU: " .. incomingData)
					self.LogFile:write("\n")
				end
				--LoSetCommand(incomingData)
			end
		else
			if CurrentTime > self.NextReconnectTryTime then
				--It's time to try another time
				self.SockCom = socket.tcp()
				self.SockCom:settimeout(self.ConnectTimeout)
				try_to_connect = self.SockCom:connect(self.RemoteAddress, self.RemotePort)
				if try_to_connect ~= nil then
					self.SockCom:setoption("tcp-nodelay", true) --No buffer, auto-flush
					self.SockCom:settimeout(0.000001) -- Permet de ne pas bloquer la lecture
					self.TryingToReconnect = false
				else
					self.SockCom = nil
				end
				self.NextReconnectTryTime = CurrentTime + self.TryToReconnectPeriod --update the time for the next try
			end
		end
		
		isMyPlaneAlive = LoGetTrueAirSpeed()

		stackMyPlane = newStack()
        stackwpt = newStack()
		if isMyPlaneAlive then
		
--	local deltaT = GetDeltaT_Player(LoGetModelTime())
		local Moi    = LoGetObjectById(LoGetPlayerPlaneId())
		local lat2   = Moi.LatLongAlt.Lat
		local lng2   = Moi.LatLongAlt.Long
		local alt2   = Moi.LatLongAlt.Alt
		local X ,Z   = getXZCoords(lat2, lng2)		
		local hdg2   = math.deg(Moi.Heading)
		local deltaT, deltaD, Cap, GS, deltaF = GetDeltaX_Player(X, Z)	-- tps sec,dist parcourue m, GroundSpeed m/s, conso fuel kg

--	local deltaD = GetDeltaD_Player(last_lat, last_lng, lat2, lng2)
--	local deltaF = GetDeltaFuel_Player()
--	local GS     = GetGroundSpeed_Player(deltaD , deltaT)

		addString(stackMyPlane, string.format("%.3f|",last_t))
		addString(stackMyPlane, LoGetPlayerPlaneId() .. "|")
		addString(stackMyPlane, string.format("%.4f|%.4f|",lat2, lng2))
 		addString(stackMyPlane, string.format("%.3f|%.3f",X, Z))
		addString(stackMyPlane, "VT") 		
		addString(stackMyPlane, string.format("%d|", hdg2))								    --Heading 		
--		addString(stackMyPlane, string.format("%d|",LoGetIndicatedAirSpeed() * 3.6)) 		--IAS	km/h
--		addString(stackMyPlane, string.format("%d|",LoGetTrueAirSpeed() * 3.6))				--TAS   km/h
--		addString(stackMyPlane, string.format("%d|",GS * 3.6))								--GS	km/h
--		addString(stackMyPlane, string.format("%.1f|",LoGetMachNumber()))					--MACH	mach
--		addString(stackMyPlane, string.format("%d|",LoGetAltitudeAboveSeaLevel())) 			--ASL   m
--		addString(stackMyPlane, string.format("%d|",LoGetAltitudeAboveGroundLevel()))		--AGL   m
		addString(stackMyPlane, LoGetNavigationInfo().SystemMode.master)                    --MasterMode
		addString(stackMyPlane, " " .. LoGetNavigationInfo().SystemMode.submode)            --SubMode
		addString(stackMyPlane, "VT") 		
		addString(stackMyPlane, string.format("%.2f|",LoGetMachNumber()))					--MACH	mach
		addString(stackMyPlane, string.format("%d", FuelRestant))  						    --fuel restant en kg

		local conso_km  = 0
		local conso_mn  = 0

		if deltaF >= 0 and deltaD > 5 then
			conso_km =  deltaF / deltaD  				-- g/m ou kg/km
			conso_mn =  deltaF / deltaT * (60 / 1000)	-- kg/mn
			local lat3, lng3 = getLatAndLong(LoGetRoute().goto_point.world_point.x, LoGetRoute().goto_point.world_point.z)
			local dp, cp = GetDistAndCapXZ(X, Z, LoGetRoute().goto_point.world_point.x, LoGetRoute().goto_point.world_point.z)
			addString(stackwpt, "WP")
			TOSforAllWPT(dp, cp, GS, stackwpt )
			addString(stackwpt, "WP")
			addString(stackwpt, string.format("%.3f|", conso_km))  				-- conso kg/km
			addString(stackwpt, string.format("%.3f|", conso_mn))	            -- conso kg/mn			
			addString(stackwpt, string.format("%d|", FuelRestant / conso_km))	-- nbr de km possible
			addString(stackwpt, string.format("%d", FuelRestant / conso_mn))	-- tps de vol (mn) possible
		 end
		 
--      "PV"
--01	LoGetPilotName()		
--02	LoGetPlayerPlaneId()
--03	LoGetMissionStartTime()
--       Nbr WP x 7
--04	num 1er WP              (1er WP = 0)
--05	world_point.x
--06	world_point.z
--07	getLatitude(world_point.x, world_point.z)
--08	getLongitude(world_point.x, world_point.z)
--09 	Altitude requise  ce WP
--10	num WP suivant ( -1 = fin)
--

--01		last_t
--02		LoGetPlayerPlaneId()
--03		Moi.LatLongAlt.Lat  en degree
--04		Moi.LatLongAlt.Long en degree
--05  		X   coord lockon
--06  		Z   coord lockon
--07		LoGetIndicatedAirSpeed() en	km/h
--08		LoGetTrueAirSpeed()	     en km/h
--09		GSpeed 					 en	km/h
--10		LoGetAltitudeAboveSeaLevel() 	en m
--11		LoGetAltitudeAboveGroundLevel() en m
--12        Fuel restant 		en kg
--13		LoGetRoute().goto_point.this_point_num
--14        Heading
--15		LoGetMachNumber()	en mach
--16        LoGetNavigationInfo().SystemMode.master
--17        LoGetNavigationInfo().SystemMode.submode
--
--18		FuelRestant / conso_km  nbr de km possible
--19		FuelRestant / conso_mn	tps de vol (mn) possible
--20		conso_km	en kg/km
--21		conso_mn	en kg/mn
--          "WPT"
--          wpt, km restant, cap, tos, eta (x fois)

		end --Enf if my plane is alive
		
--		stackObjects = newStack()
		
		--_objects
--		local objects = LoGetWorldObjects()
--		if objects then
--			for key,object in pairs(objects) do
				--_BasicObject>")
--					writeObjectPropertyInStack(stackObjects, object, key)
--			end
--		end
			
		DataPlayerPlane = table.concat(stackMyPlane) .. table.concat(stackwpt)
		if DataPlayerPlane == "" then
			return
		end
		if self.Debug == "1" then
			self.LogFile:write(DataPlayerPlane)
			self.LogFile:write("\n")
		end
			
		if self.SockCom then
			rep = self.SockCom:send(DataPlayerPlane)
			if rep == nil then
				self.SockCom = nil
			end
		end
	end,
		
	-- --------------------------------------------------------------------
	-- Fonction d'arrt du script
	-- --------------------------------------------------------------------
	Stop=function(self)
		if self.LogFile then
			self.LogFile:write("**** END SPEAKING ****\n")
			io.close(self.LogFile)
		end
		self.SockCom:send("****END SPEAKING")
		if self.SockCom then
			self.SockCom:close()
		end
	end,
}

-- --------------------------------------------------------------------------------------------

-- Works once just before mission start.
do
	local PrevLuaExportStart=LuaExportStart;

	LuaExportStart=function()
		LoLibData:Start();

		if PrevLuaExportStart then
			PrevLuaExportStart();
		end
	end
end

-- Works just after every simulation frame.
do
	local PrevLuaExportAfterNextFrame=LuaExportAfterNextFrame;

	LuaExportAfterNextFrame=function()
		LoLibData:Update();

		if PrevLuaExportAfterNextFrame then
			PrevLuaExportAfterNextFrame();
		end
	end
end

-- Works once just after mission stop.
do
	local PrevLuaExportStop=LuaExportStop;

	LuaExportStop=function()
		LoLibData:Stop();

		if PrevLuaExportStop then
			PrevLuaExportStop();
		end
	end
end
